<?php

class Informer {

    function GetFileInformation($template) {

        // Read in template file, suppress error messages
        $content = @implode("", (@file($template)));
        preg_match_all("/\[LastUpdate: .*\]/",$content,$date);
        preg_match_all("/\[FileName: .*\]/",$content,$filename);

        $information["date"] = $date[0][0];
        $information["filename"] = $filename[0][0];

        return $information;

    }

    function GetDb($dbdir,$dbfile,$checkfile_name,$checkfile_date) {

        $re_date = false;
        $checkfile_date = trim(preg_replace("/\[LastUpdate:/","",$checkfile_date));
        $checkfile_date = trim(preg_replace("/\]/","",$checkfile_date));
        $fp = @fopen($dbdir.$dbfile,"r") or die ("Could not open $dbfile for read access");
        $fpt = @fopen($dbdir."tmp_dbase.txt","w") or die ("Could not open temp-file for write access");
        while ($line = @fgets($fp,1024)) {

              $write_flag = false;
              $filename_exists = false;

              list ($filename, $date) = explode ("||", $line);



              if  ($filename == $checkfile_name) {

                $filename_exists = true;
                $date = trim($date);

                $date_time = split("--",$date);
                $checkfile_date_time = split("--",$checkfile_date);


                $date_parts = split("\.",$date_time[0]);
                $time_parts = split(":",$date_time[1]);
                $check_date = gmmktime( $time_parts[0],$time_parts[1],$time_parts[2],$date_parts[1],$date_parts[0],$date_parts[2]);

                $date_parts = split("\.",$checkfile_date_time[0]);
                $time_parts = split(":",$checkfile_date_time[1]);
                $checkfile_date_ = gmmktime($time_parts[0],$time_parts[1],$time_parts[2],$date_parts[1],$date_parts[0],$date_parts[2]);


                if ($checkfile_date_>$check_date) {

                        $write_flag = true;
                        $re_date = true;

                }

                if ($write_flag == true) {

                        $date = $checkfile_date;

                }


              }

                $date = preg_replace("/\n/","",$date);
                if (trim($filename)!="") {
                        $newline = $filename."||".$date."\n";

                        fputs($fpt,$newline);
                }
        }

        if ($filename_exists == false) {

                //datei ist noch nicht vorhanden
                //wird jetzt hinzugefgt
                fputs($fpt,$checkfile_name."||".$checkfile_date."\n");

        }

        fclose($fp);
        fclose($fpt);

        copy ($dbdir."tmp_dbase.txt",$dbdir.$dbfile);
        unlink ($dbdir."tmp_dbase.txt");

        return $re_date;
    }

    function SendMail($addir,$file_name,$subject,$text,$absender) {

        $file_name = preg_replace("/\..*/",".txt",$file_name);
        $fp = @fopen($addir.$file_name,"r") or die ("Could not open $dbfile for read access");
        while ($line = @fgets($fp,1024)) {
                 $empfaenger = trim(preg_replace("/\n/","",$line));
                 $absender = trim(preg_replace("/\n/","",$absender));
                 mail("$empfaenger","$subject","$text","From: $absender\nReply-To: $absender\n");
        }
    }

    function CheckMail($addir,$file_name,$email,$error_m,$success) {

        $ex = false;

        $file_name = preg_replace("/\..*/",".txt",$file_name);
        $fp = @fopen($addir.$file_name,"r+") or die ("Could not open $file_name for read access");
        $fpt = @fopen($addir."tmp_".$file_name,"w") or die ("Could not open temp-file for write access");

        while ($line = @fgets($fp,1024)) {
                $line = trim($line);
                if($line==$email) {
                        $message["fehler"] = $error_m;
                        $ex = true;
                }else {

                        fputs($fpt,$line."\n");
                }
        }

        if ($ex == false) {

                fputs($fpt,$email."\n");
                $message["erfolg"] = $success;

        }

        fclose($fp);
        fclose($fpt);

        copy ($addir."tmp_".$file_name,$addir.$file_name);
        unlink ($addir."tmp_".$file_name);

        return $message;


    }

}
?>